//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Generator.Test.TestReference
{


    /// <summary>
    /// Data transfer object for the request of the Run Rx Observable command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class RunRxObservableRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {

        /// <summary>
        /// Create a new instance
        /// </summary>
        public RunRxObservableRequestDto()
        {
        }

        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public RunRxObservableRequestDto( Tecan.Sila2.IBinaryStore store )
        {
        }

        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "tecan.sila.generator.test/testreference/RxService/v4/Command/RunRxObservable";
            }
        }

        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }

        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }

    /// <summary>
    /// Data transfer object for the intermediate response of the Run Rx Observable command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class RunRxObservableIntermediateDto : Tecan.Sila2.ISilaTransferObject
    {

        private Tecan.Sila2.BooleanDto _intermediate;

        /// <summary>
        /// Create a new instance
        /// </summary>
        public RunRxObservableIntermediateDto()
        {
        }

        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public RunRxObservableIntermediateDto( bool intermediate, Tecan.Sila2.IBinaryStore store )
        {
            Intermediate = new Tecan.Sila2.BooleanDto( intermediate, store );
        }

        [ProtoBuf.ProtoMemberAttribute( 1 )]
        public Tecan.Sila2.BooleanDto Intermediate
        {
            get
            {
                return _intermediate;
            }
            set
            {
                _intermediate = value;
            }
        }

        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate( Intermediate, "intermediate" );
        }

        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require( Intermediate, "intermediate" ));
        }
    }
}
